<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Attributes\Appends;
use Illuminate\Database\Eloquent\Attributes\Guarded;
use Illuminate\Database\Eloquent\Casts\Attribute;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\SoftDeletes;

#[Appends(['formatted_material_result'])]
#[Guarded(['id'])]
class CuttingMaterialCombination extends Model
{
    use HasFactory, SoftDeletes;

    protected function casts(): array
    {
        return [
            'material_result' => 'integer',
        ];
    }

    protected function formattedMaterialResult(): Attribute
    {
        return Attribute::make(
            get: fn () => number_format($this->material_result, 0, ',', '.'),
        );
    }

    public function cutting(): BelongsTo
    {
        return $this->belongsTo(Cutting::class);
    }

    public function cuttingMaterials(): HasMany
    {
        return $this->hasMany(CuttingMaterial::class, 'combination_id');
    }

    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }
}
